#include<string>
#include<ctime>
#include<cstdlib>
#include<iostream>
#include<vector>
#include<algorithm>
#include "cellular.h"

using namespace std;


CellularAutomaton::CellularAutomaton(int therule, int length, int randomP){
  // first initialize first generation
  
  if(randomP == 1){
    srand(time(NULL));
    for(int i = 0; i < length; i++){
      if((rand() % 3) == 0){
        generation.push_back(1);
      }
      else{
        generation.push_back(0);
      }
    }
  }
  else {
    vector<int> newGeneration(length, 0);
    newGeneration[(length / 2) + 1] = 1;
    generation = newGeneration;
  }
  cout << "storing rule \n";
  rule = vector<int>(8,0);
  for (int i = 7; i >=0; i--){
      rule[i] = therule % 2;
      therule /= 2; 
  }
}

void CellularAutomaton::printGeneration(){
   for(auto &i : generation){
     if(i == 1){
      cout << "\u2588";
     }
     else{
       cout << " ";
     }
   }
   cout << endl;
}

void CellularAutomaton::printRule(){
  for(auto &i : rule){
    cout << i;
  }
  cout << endl;
}

void CellularAutomaton::nGenerations(int years){
     for (int i = 0; i < years; i++){
         printGeneration();
         nextGeneration();
     }
     printGeneration();
}

void CellularAutomaton::nextGeneration(){
  vector<int> oldGeneration(generation);
  int currentRule;
  int gsize = generation.size();
  for (unsigned int i = 0; i < gsize; i++){
     currentRule = 7 - ((oldGeneration[((i+gsize) - 1) % gsize] * 4) + (oldGeneration[i] * 2)  +  (oldGeneration[(i + 1) % gsize])) ;
     generation[i] = rule[currentRule];     
  }
}



